/*
 * pib_messagea.c
 *
 * Copyright (C) 2020 Peter Belkner <pbelkner@users.sf.net>
 * Nanos gigantum humeris insidentes #TeamWhite
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.0 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301  USA
 */
#include <pib.h>

void pib_messagea(const char *messagea)
{
#if 0 // [
  char captiona[128];
  int code;

  sprintf(captiona,"%s Error",plugin_titlea());

  code=MessageBoxA(
    pib_hwnd_parent(),        // HWND    hWnd,
    messagea,                 // LPCTSTR lpText,
    captiona,                 // LPCTSTR lpCaption,
    MB_OKCANCEL|MB_ICONERROR  // UINT    uType
  );

  if (IDOK==code)
    exit(1);
#else // ] [
  enum { SIZE=1024 };
  wchar_t messagew[SIZE];

  MultiByteToWideChar(
    CP_ACP,       // UINT                              CodePage,
    0,            // DWORD                             dwFlags,
    messagea,     // _In_NLS_string_(cbMultiByte)LPCCH lpMultiByteStr,
    -1,           // int                               cbMultiByte,
    messagew,     // LPWSTR                            lpWideCharStr,
    SIZE          // int                               cchWideChar
  );

  pib_messagew(messagew);
#endif // ]
}

void pib_vmessagea(const char *message, ...)
{
  enum { SIZE=1024 };
  char buf[SIZE];
  va_list ap;

  va_start(ap,message);
  vsnprintf(buf,SIZE,message,ap);
  va_end(ap);
  pib_messagea(buf);
}
