/*
 * pib_messagew.c
 *
 * Copyright (C) 2020 Peter Belkner <pbelkner@users.sf.net>
 * Nanos gigantum humeris insidentes #TeamWhite
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.0 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301  USA
 */
#include <pib.h>

void pib_messagew(const wchar_t *messagew)
{
  enum { SIZE=128 };
  wchar_t captionw[SIZE];
  int code;

  swprintf(
    captionw,                 // wchar_t *buffer,
    SIZE,                     // size_t count,
    L"%s Error",              // const wchar_t *format [,
    plugin_titlew()           // argument]...
  );

  code=MessageBoxW(
    pib_hwnd_parent(),        // HWND    hWnd,
    messagew,                 // LPCTSTR lpText,
    captionw,                 // LPCTSTR lpCaption,
    MB_OKCANCEL|MB_ICONERROR  // UINT    uType
  );

  if (IDOK==code)
    exit(1);
}

void pib_vmessagew(const wchar_t *message, ...)
{
  enum { SIZE=1024 };
  wchar_t buf[SIZE];
  va_list ap;

  va_start(ap,message);
  _vsnwprintf_s(buf,SIZE,_TRUNCATE,message,ap);
  va_end(ap);
  pib_messagew(buf);
}
