/*
 * pib_thread_request.c
 *
 * Copyright (C) 2020 Peter Belkner <pbelkner@users.sf.net>
 * Nanos gigantum humeris insidentes #TeamWhite
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.0 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301  USA
 */
#include <pib.h>

void *pib_thread_request_common_new(PibThreadRequestVmt *vmt,
    PibThread *thread, size_t size)
{
  PibThreadRequest *request=malloc((sizeof *request)+size);

  if (!request) {
    DMESSAGE("allocating request");
    goto e_request;
  }

  request->vmt=vmt;
  request->thread=thread;
  request->prev=NULL;
  request->next=NULL;

  return request;
//cleanup:
  free(request);
e_request:
  return NULL;
}

void pib_thread_request_common_destroy(PibThreadRequest *request)
{
  free(request);
}
