/*
 * pib_widget_box.c
 *
 * Copyright (C) 2020 Peter Belkner <pbelkner@users.sf.net>
 * Nanos gigantum humeris insidentes #TeamWhite
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.0 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301  USA
 */
#include <pib_widget.h>

PibWidget *pib_widget_box_new(PibWidgetVmt *vmt, int border, int delta)
{
  PibWidget *widget=pib_widget_list_new_ex(vmt);

  if (!widget) {
    DMESSAGE("creating box");
    goto e_box;
  }

  PIB_WIDGET_BOX(widget)->border=border;
  PIB_WIDGET_BOX(widget)->delta=delta;

  return widget;
//cleanup:
  pib_widget_list_vmt()->destroy(widget);
e_box:
  return NULL;
}

static SIZE *_pib_widget_box_geometry(PibWidget *widget)
{
  return &PIB_WIDGET_BOX(widget)->geometry;
}

PibWidgetVmt *pib_widget_box_vmt(void)
{
  static PibWidgetVmt vmt;
  PibWidgetVmt *prev;

  if (!vmt.destroy) {
    prev=pib_widget_list_vmt();
    vmt=*prev;
    vmt.id=PIB_WIDGET_ID_BOX;
    vmt.size=sizeof (PibWidgetBox);
    vmt.prev=prev;
    vmt.geometry=_pib_widget_box_geometry;
  }

  return &vmt;
}
