/*
 * pib_widget_vbox.c
 *
 * Copyright (C) 2020 Peter Belkner <pbelkner@users.sf.net>
 * Nanos gigantum humeris insidentes #TeamWhite
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.0 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301  USA
 */
#include <pib_widget.h>

static void _pib_widget_vbox_accept(PibWidget *widget,
    PibWidgetAcceptor *acceptor)
{
  acceptor->vmt->dispatch_vbox(acceptor,widget);
}

PibWidgetVmt *pib_widget_vbox_vmt(void)
{
  static PibWidgetVmt vmt;
  PibWidgetVmt *prev;

  if (!vmt.destroy) {
    prev=pib_widget_box_vmt();
    vmt=*prev;
    vmt.id=PIB_WIDGET_ID_VBOX;
    vmt.prev=prev;
    vmt.accept=_pib_widget_vbox_accept;
  }

  return &vmt;
}
