/*
 * pib_ws2cs.c
 *
 * Copyright (C) 2020 Peter Belkner <pbelkner@users.sf.net>
 * Nanos gigantum humeris insidentes #TeamWhite
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.0 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301  USA
 */
#include <pib.h>

char *pib_ws2cs(const wchar_t *ws, char *cs, size_t size)
{
#if 0 // [
  MultiByteToWideChar(
    CP_ACP,       // UINT                              CodePage,
    0,            // DWORD                             dwFlags,
    messagea,     // _In_NLS_string_(cbMultiByte)LPCCH lpMultiByteStr,
    -1,           // int                               cbMultiByte,
    messagew,     // LPWSTR                            lpWideCharStr,
    SIZE          // int                               cchWideChar
  );
#else // ] [
  WideCharToMultiByte(
    CP_ACP,       // UINT                               CodePage,
    0,            // DWORD                              dwFlags,
    ws,           // _In_NLS_string_(cchWideChar)LPCWCH lpWideCharStr,
    -1,           // int                                cchWideChar,
    cs,           // LPSTR                              lpMultiByteStr,
    size,         // int                                cbMultiByte,
    NULL,         // LPCCH                              lpDefaultChar,
    NULL          // LPBOOL                             lpUsedDefaultChar
  );
#endif // ]

  return cs;
}
