/*
 * xwidget.c
 *
 * Copyright (C) 2020 Peter Belkner <pbelkner@users.sf.net>
 * Nanos gigantum humeris insidentes #TeamWhite
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.0 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301  USA
 */
#include <pib_widget.h>

HINSTANCE plugin_hinstance(void)
{
  return NULL;
}

HWND plugin_hwnd_main(void)
{
  return NULL;
}

const wchar_t *plugin_titlew(void)
{
  return L"xwidget";
}

#define MAIN_COMBOBOX
#define MAIN_TREEVIEW
PibWidget *main_hbox_inner_new(int border)
{
  PibWidget *box,*widget;

  box=pib_widget_hbox_new(border,4);
  widget=pib_widget_button_new(L"Rollback");
  pib_widget_box_append(PIB_WIDGET_BOX(box),PIB_WIDGET_NONE,
      PIB_WIDGET_BEGIN,widget);
  widget=pib_widget_button_new(L"Commit");
  pib_widget_box_append(PIB_WIDGET_BOX(box),PIB_WIDGET_NONE,
      PIB_WIDGET_BEGIN,widget);
  widget=pib_widget_button_new(L"Cancel");
  pib_widget_box_append(PIB_WIDGET_BOX(box),PIB_WIDGET_NONE,
      PIB_WIDGET_BEGIN,widget);
  widget=pib_widget_button_new(L"OK");
  pib_widget_box_append(PIB_WIDGET_BOX(box),PIB_WIDGET_NONE,
      PIB_WIDGET_BEGIN,widget);

  return box;
}

PibWidget *main_vbox_inner_new(int border)
{
#if defined (MAIN_COMBOBOX) // [
  static PibWidgetComboboxMap map[]={
#if 0 // [
    { L"012345678901234567890123456789", 99 },
#endif // ]
    { L"8",   8 },
    { L"10", 10 },
    { L"12", 12 },
    { NULL,  -1 },
  };
#endif // ]

  PibWidget *box,*widget;

  box=pib_widget_vbox_new(border,4);
#if 1 // [
  widget=pib_widget_button_new(L"Hello");
  pib_widget_box_append(PIB_WIDGET_BOX(box),PIB_WIDGET_CENTER,
      PIB_WIDGET_NONE,widget);
#endif // ]
#if defined (MAIN_COMBOBOX) // [
  widget=pib_widget_combobox_new(map);
  pib_widget_box_append(PIB_WIDGET_BOX(box),PIB_WIDGET_CENTER,
      PIB_WIDGET_NONE,widget);
#endif // ]
  widget=pib_widget_button_new(L"012345678901234567890123456789");
  pib_widget_box_append(PIB_WIDGET_BOX(box),PIB_WIDGET_CENTER,
      PIB_WIDGET_NONE,widget);
  widget=pib_widget_button_new(L"Rollback");
  pib_widget_box_append(PIB_WIDGET_BOX(box),PIB_WIDGET_CENTER,
      PIB_WIDGET_NONE,widget);
  widget=pib_widget_button_new(L"Commit");
  pib_widget_box_append(PIB_WIDGET_BOX(box),PIB_WIDGET_CENTER,
      PIB_WIDGET_NONE,widget);
  widget=pib_widget_button_new(L"Cancel");
  pib_widget_box_append(PIB_WIDGET_BOX(box),PIB_WIDGET_CENTER,
      PIB_WIDGET_NONE,widget);
  widget=pib_widget_button_new(L"OK");
  pib_widget_box_append(PIB_WIDGET_BOX(box),PIB_WIDGET_CENTER,
      PIB_WIDGET_NONE,widget);

  return box;
}

PibWidget *main_vbox_outer_new(int border)
{
  enum { VBOX_OUTER_MODE=PIB_WIDGET_CENTER };
  PibWidget *box,*widget;

  box=pib_widget_vbox_new(border,4);
#if 1 // [
  widget=pib_widget_button_new(L"Hello");
  pib_widget_box_append(PIB_WIDGET_BOX(box),VBOX_OUTER_MODE,
      PIB_WIDGET_NONE,widget);
#endif // ]
  widget=main_vbox_inner_new(0);
  pib_widget_box_append(PIB_WIDGET_BOX(box),VBOX_OUTER_MODE,
      PIB_WIDGET_CENTER,widget);
  widget=main_hbox_inner_new(0);
  pib_widget_box_append(PIB_WIDGET_BOX(box),VBOX_OUTER_MODE,
      PIB_WIDGET_NONE,widget);

  return box;
}

PibWidget *main_vbox_inner2_new(int border)
{
  enum { VBOX_INNER_MODE=PIB_WIDGET_CENTER };
  PibWidget *box,*widget;

  box=pib_widget_vbox_new(border,4);
  widget=pib_widget_button_new(L"1");
  pib_widget_box_append(PIB_WIDGET_BOX(box),VBOX_INNER_MODE,
      PIB_WIDGET_END,widget);
  widget=pib_widget_button_new(L"2");
  pib_widget_box_append(PIB_WIDGET_BOX(box),VBOX_INNER_MODE,
      PIB_WIDGET_NONE,widget);

  return box;
}

#if defined (MAIN_TREEVIEW) // [
#if 1 // [
PibWidget *main_hbox_outer_new(int border)
{
  enum { HBOX_OUTER_MODE=PIB_WIDGET_CENTER };
  PibWidget *box,*widget;

  box=pib_widget_hbox_new(border,4);
  widget=pib_widget_treeview_new(120,200);
  pib_widget_box_append(PIB_WIDGET_BOX(box),PIB_WIDGET_NONE,HBOX_OUTER_MODE,
      widget);
  widget=main_vbox_outer_new(0);
  pib_widget_box_append(PIB_WIDGET_BOX(box),PIB_WIDGET_NONE,HBOX_OUTER_MODE,
      widget);

  return box;
}
#else // ] [
PibWidget *main_hbox_outer_new(int border)
{
  enum { HBOX_OUTER_MODE=PIB_WIDGET_NONE };
  PibWidget *box,*widget;

  box=pib_widget_vbox_new(border,4);
#if 0 // [
  widget=pib_widget_treeview_new(120,200);
#else // ] [
  widget=pib_widget_button_new(L"012345678901234567890123456789");
#endif // ]
  pib_widget_box_append(PIB_WIDGET_BOX(box),PIB_WIDGET_NONE,HBOX_OUTER_MODE,
      widget);
#if 0 // [
  widget=pib_widget_treeview_new(120,200);
  pib_widget_box_append(PIB_WIDGET_BOX(box),PIB_WIDGET_NONE,HBOX_OUTER_MODE,
      widget);
#endif // ]

  return box;
}
#endif // ]
#endif // ]

#if defined (PIB_WIDGET_REALIZER2) // [
//#define MAIN_COMBOBOX2
#endif // ]
int main(int argc, char **argv)
{
#if defined (MAIN_COMBOBOX2) // [
  static PibWidgetComboboxMap map[]={
#if 1 // [
    //{ L"012345678901234567890123456789", 99 },
    { L"Good bye crule word! Good bye crule word!", 99 },
#endif // ]
    { L"8",   8 },
    { L"10", 10 },
    { L"12", 12 },
    { NULL,  -1 },
  };
#endif // ]

  static const wchar_t TITLE[]
      =L"[Y]et [A]nother Winamp [P]lug-[i]n [B]undle (YAPiB) Cockpit v0.0.0";

  int point_size=argc<2?8:atoi(argv[1]);
  PibWidget *box;

  DCREATE(); // {
#if defined (PIB_WIDGET_REALIZER2) // [
#if defined (MAIN_COMBOBOX2) // [
  box=pib_widget_combobox_new(map);
#else // ] [
  //box=pib_widget_button_new(L"Good bye crule word! Good bye crule word!");
  box=main_hbox_outer_new(0);
#endif // ]
  //box=pib_widget_button_new(L"012345678901234567890123456789");
  //box=pib_widget_button_new(L"Reset");
  //box=pib_widget_button_new(L"OK");
#else // ] [
  box=main_hbox_outer_new(4);
#endif // ]
  pib_widget_ref(box); // {

  pib_widget_run(
    box,                // PibWidget *widget,
#if defined (PIB_WIDGET_REALIZER2) // [
    4,                  // int border,
#endif // ]
    TITLE,              // const wchar_t *title,
    point_size,         // WORD point_size,
    L"Ms Shell Dlg"     // const wchar_t *typeface
  );

  pib_widget_unref(box); // }
  DDESTROY(); // }

  return 0;
}
