# the ms c-compiler:
PATH+=:$(msvc)/VC/bin:$(msvc)/Common7/IDE
MSCPPFLAGS+='-I$(msvc)/VC/include'
$(info #####################################################)
$(info $(MSCPPFLAGS))
$(info #####################################################)
mscl:=cl.exe -nologo
# the ms librarian:
mslib:=lib.exe -nologo
ifeq (ms,$(tools)) ########################################################## [
exto:=.obj							# an object
exta:=.lib							# a library
extso:=.dll							# a shared object
extsoa:=.lib						# an import library to a shared object
# link a program from an object:
$(bindir)/%: %$(exto)
	echo "&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&"
	mkdir -p $(@D)
	$(mscl) $(CFLAGS) $(MSCPPFLAGS) $(CPPFLAGS) -Fe$@.exe $^ -link $(LDFLAGS) $(LDLIBS)
%: %$(exto)
	$(mscl) $(CFLAGS) $(MSCPPFLAGS) $(CPPFLAGS) -Fe$@.exe $^ -link $(LDFLAGS) $(LDLIBS)
# link a shared object from an object:
$(bindir)/%$(extso): %$(exto)
	$(mscl) $(CFLAGS) -LD $(MSCPPFLAGS) $(CPPFLAGS) -Fe$@ $^ -link $(LDFLAGS) $(LDLIBS)
%$(extso): %$(exto)
	$(mscl) $(CFLAGS) -LD $(MSCPPFLAGS) $(CPPFLAGS) -Fe$@ $^ -link $(LDFLAGS) $(LDLIBS)
# place some file into a library:
(%): %
	if test -e $@; then $(mslib) -out:$@ $@ $<; else $(mslib) -wx -out:$@ $<; fi
# compile an object from a c source file:
%$(exto): %.c
	$(mscl) $(CFLAGS) $(MSCPPFLAGS) $(CPPFLAGS) $< -c -Fo$@
# create an import library from a definition file:
.PRECIOUS: %$(extsoa)
%$(extdlla): %.def
	$(mslib) -machine:x86 -def:$< -out:$@
else ###################################################################### ] [
exto:=.o								# an object
exta:=.a								# a library
extso:=.dll							# a shared object
extsoa:=.dll.a					# an import library to a shared object
CC:=gcc
# we use the rules provided by Make. we just have to add some rules w.r.t.
# shared objects.
# link a program from an object:
$(bindir)/%: %$(exto)
#  recipe to execute (built-in):
	$(LINK.o) $^ $(LOADLIBES) $(LDLIBS) -o $@
# link a shared object from an object:
%$(extso): %$(exto)
	$(CC) $(CFLAGS) $(CPPFLAGS) $^ $(LDFLAGS) $(LDLIBS) -o $@
$(bindir)/%$(extso): %$(exto)
	$(CC) $(CFLAGS) $(CPPFLAGS) $^ $(LDFLAGS) $(LDLIBS) -o $@
# create an import library from a definition file:
.PRECIOUS: %$(extsoa)
%$(extsoa): %.def
	dlltool -d $< --output-delaylib $@
endif ####################################################################### ]
